#include <htc.h>
#include "LCD.h"
#include "Generic Functions.h"
#include "timer.h"


void WriteCommandToLCD(unsigned char Command)  
{
	LCD_Data_Bus = Command;   // Write Command on data bus
	LCD_RW = 0;               // We are writing to LCD
	LCD_RS = 0;               // It is a command

	LCD_E = 1;                // Give a pulse on E pin
	Delay(50*DelayFactor);    // so that LCD can latch the
	LCD_E = 0;                // data from data bus
	Delay(50*DelayFactor);
}

void WriteDataToLCD(char LCDChar)  
{
	LCD_Data_Bus = LCDChar;   // Write Data on data bus
	LCD_RW = 0;               // We are writing to LCD
	LCD_RS = 1;               // It is data

	LCD_E = 1;                // Give a pulse on E pin
	Delay(50*DelayFactor);    // so that LCD can latch the
	LCD_E = 0;                // data from data bus
	Delay(50*DelayFactor);
}

void InitLCD(void)
{ 
  ///////////// Reset process from datasheet /////////
   Delay(15000*DelayFactor);
   WriteCommandToLCD(0x30);

   Delay(4500*DelayFactor);
   WriteCommandToLCD(0x30);

   Delay(300*DelayFactor);
   WriteCommandToLCD(0x30);

   Delay(650*DelayFactor);
  /////////////////////////////////////////////////////
   WriteCommandToLCD(0x38);    //function set
   WriteCommandToLCD(0x0c);    //display on,cursor off,blink off
   WriteCommandToLCD(0x01);    //clear display
   WriteCommandToLCD(0x06);    //entry mode, set increment
}

void WriteStringToLCD(const char *s)
{
	while(*s)
	{
		WriteDataToLCD(*s);   // print first character on LCD 
	}

}



void ClearLCDScreen(void)
{
	WriteCommandToLCD(0x01);    // Clear the screen
	Delay(1500*DelayFactor);    // Delay for cursor to return at zero position
}



/*void DisplayTimeToLCD( unsigned int m, unsigned int s )   // Displays time in MM:SS format
{
	ClearLCDScreen();      // Move cursor to zero location and clear screen

	/* Display Hour
	WriteDataToLCD( (h/10)+0x30 );
	WriteDataToLCD( (h%10)+0x30 );

	//Display ':'
	WriteDataToLCD(':'); 

	//Display Minutes
	WriteDataToLCD( (m/10)+0x30 );
	WriteDataToLCD( (m%10)+0x30 );

	//Display ':'
	WriteDataToLCD(':');

	//Display Seconds
	WriteDataToLCD( (s/10)+0x30 );
	WriteDataToLCD( (s%10)+0x30 );
}*/